using System;
using System.Collections.Generic;
using System.Text;

namespace AttributeFactory
{
    public abstract class AbstractFactory : IAbstractFactory
    {
        public T Create<T>()
        {
            foreach (Product product in Search<T>())
            {
                //      
                return (T)product.Concrete.GetConstructor(Type.EmptyTypes).Invoke(null);
            }
            // throw new ArgumentException();
            return default(T);
        }

        private IEnumerable<Product> Search<T>()
        {
            Product[] products = (Product[])GetType().GetCustomAttributes(typeof(Product), true);
            Type type = typeof(T);
            foreach (Product product in products)
            {
                if (type == product.Abstract)
                {
                    yield return product;
                }
            }
        }

        public bool IsProduct<T>()
        {
            return Search<T>().GetEnumerator().MoveNext();
        }
    }
}
