using System;
using System.Collections.Generic;
using System.Text;

namespace Factory
{
    public abstract class AbstractFactory : IAbstractFactory
    {
        public T Create<T>()
        {
            IFactoryMethod<T> factoryMethod = this as IFactoryMethod<T>;
            if (factoryMethod != null)
            {
                return factoryMethod.Create();
            }
            //    Exception,  
            //  IFactoryMethod<T>   
            return default(T);
        }

        public bool IsProduct<T>()
        {
            return this is IFactoryMethod<T>;
        }
    }
}
