using System;
using System.Collections.Generic;
using System.Text;

namespace Factory
{
    public abstract class CloneFactory : AbstractFactory, ICloneFactory
    {
        public void SetPrototype<T>(T prototype)
            where T : ICloneable
        {
            ICloneMethod<T> cloneMethod = this as ICloneMethod<T>;
            if (cloneMethod != null)
            {
                cloneMethod.Prototype = prototype;
            }
            // throw new ArgumentException();
        }

        public T GetPrototype<T>()
            where T : ICloneable
        {
            ICloneMethod<T> cloneMethod = this as ICloneMethod<T>;
            if (cloneMethod != null)
            {
                return cloneMethod.Prototype;
            }
            // throw new ArgumentException();
            return default(T);
        }
    }
}
