using System;
using System.Collections.Generic;
using System.Text;

namespace Factory
{
    public class GUIToolkit : CloneFactory, IFactoryMethod<Edit>, ICloneMethod<Button>
    {
        Edit IFactoryMethod<Edit>.Create()
        {
            return new StyledEdit();
        }

        private Button buttonPrototype;

        Button ICloneMethod<Button>.Prototype
        {
            get { return buttonPrototype; }
            set { buttonPrototype = value; }
        }

        Button IFactoryMethod<Button>.Create()
        {
            return (Button)buttonPrototype.Clone();
        }
    }
}
