using System;
using System.Collections.Generic;
using System.Text;

namespace GenericFactory
{
    public abstract class AbstractFactory : IAbstractFactory
    {
        public T Create<T>()
        {
            IFactoryMethod<T> factoryMethod = this as IFactoryMethod<T>;
            if (factoryMethod != null)
            {
                return factoryMethod.Create();
            }
            // throw new ArgumentException();
            return default(T);
        }

        public bool IsProduct<T>()
        {
            return this is IFactoryMethod<T>;
        }
    }
}
