using System;
using System.Collections.Generic;
using System.Text;

namespace PrototypeFactory
{
    public interface IAbstractFactory
    {
        T Create<T>()
            where T : ICloneable;

        bool IsProduct<T>()
            where T : ICloneable;

        void SetPrototype<T>(T prototype)
            where T : ICloneable;

        T GetPrototype<T>()
            where T : ICloneable;
    }
}
